import gab.opencv.*;
import processing.video.*;
import java.awt.*;
 
Movie movie; // 動画
OpenCV opencv; // 顔認識
PImage usamin; // 顔画像（左） 画面の中央より左半分にある顔領域用
PImage sugarHeart; // 顔画像（右）　画面の中央より右半分にある顔領域用
boolean moviePlaying; // 再生中判定フラグ
float faceZoom; // 顔画像の拡大率
Rectangle[] faces; // 顔領域保管変数

MovieEffect facialRecognition;
MovieEffect collage;
MovieEffect bluebackMaterial;
MovieEffect blueMaterial;
MovieEffect bluebackMovie;
MovieEffect bluebackMovieReverse;


void setup() {

  size(480, 360); // サイズの縦横比は読込動画と同じ比率にしてください
  movie = new Movie(this, "ぬるぬるBABY_458x354.mp4"); // dataフォルダの動画ファイル名 
  usamin = loadImage("usamin3D.png"); // dataフォルダの動画ファイル名
  sugarHeart = loadImage("sugarHeart3D.png"); // dataフォルダの動画ファイル名
  faceZoom = 2;
  textSize(height/30);
  opencv = new OpenCV(this, 458, 354); //読込動画の縦横を指定してください
  
  colorMode(ARGB);
  opencv.loadCascade(OpenCV.CASCADE_FRONTALFACE);  //顔認識準備
    
  facialRecognition = new FacialRecognition(width*0/3, height*0/3, width*2/3, height*2/3, usamin, sugarHeart, faceZoom);
  collage           = new Collage(          width*2/3, height*0/3, width*1/3, height*1/3, usamin, sugarHeart, faceZoom);
  bluebackMaterial  = new BluebackMaterial( width*2/3, height*1/3, width*1/3, height*1/3, usamin, sugarHeart, faceZoom);
  blueMaterial      = new BlueMaterial(     width*0/3, height*2/3, width*1/3, height*1/3, usamin, sugarHeart, faceZoom);
  bluebackMovie     = new BluebackMovie(    width*1/3, height*2/3, width*1/3, height*1/3, usamin, sugarHeart, faceZoom);
  bluebackMovieReverse = new BluebackMovieReverse(width*2/3, height*2/3, width*1/3, height*1/3, usamin, sugarHeart, faceZoom);
    
  moviePlaying = false;
  movie.noLoop();
  movie.play();  // 動画を再生

}
 
void draw() {
  imageMode(CORNER);
  if (moviePlaying){
    opencv.loadImage(movie);
    faces = opencv.detect();

    facialRecognition.draw(movie, faces);
    collage.draw(movie, faces);
    bluebackMaterial.draw(movie, faces);
    blueMaterial.draw(movie, faces);
    bluebackMovie.draw(movie ,faces);
    bluebackMovieReverse.draw(movie ,faces);
    
    g.removeCache(movie);
  }  
}
 
void movieEvent(Movie m) {
  m.read();
  moviePlaying = (m.height>0)&&(m.width>0);
}

void keyReleased(){
  if (key == CODED){
    switch(keyCode){
      case UP:
        break;
      case DOWN:
        movie.pause();
        break;
      case LEFT:
        movie.stop();
        break;
      case RIGHT:
        movie.play();
        break;
      default:
        break;
    }
  }
}