class BlueMaterial extends MovieEffect{

  PImage drawFace;
  PImage blueLeftFace;
  PImage blueRightFace;

  BlueMaterial(int displayAreaX, int displayAreaY, int displayAreaWidth, int displayAreaHeight, PImage leftFace, PImage rightFace, float faceZoom){
    super(displayAreaX, displayAreaY, displayAreaWidth, displayAreaHeight, leftFace, rightFace, faceZoom);
    blueLeftFace = changeBlueMaterial(super.leftFace); println();
    super.leftFace = blueLeftFace;
    blueRightFace = changeBlueMaterial(super.rightFace);
    super.rightFace = blueRightFace;
  }

  PImage changeBlueMaterial(PImage material){
    int imageWidth = material.pixelWidth;
    int imageHeight = material.pixelHeight;
    int alphaValue;
    int colorValue;
    PImage changed = createImage(imageWidth, imageHeight, material.format);
    
    alphaValue = material.pixels[0];
    for (int i=0; i<imageHeight; i++){
      for (int j=0; j<imageWidth; j++){
        if ( material.pixels[i*imageWidth+j] == alphaValue ){
          colorValue = alphaValue;
        }
        else{
          colorValue = unhex("FF0000FF");
        }
        changed.pixels[i*imageWidth+j] = colorValue;
      }
    }
    return changed;
  }
  
}