class BluebackMovieReverse extends MovieEffect{

  PImage changedpImage;
  int changeRange = 30;

  BluebackMovieReverse(int displayAreaX, int displayAreaY, int displayAreaWidth, int displayAreaHeight, PImage leftFace, PImage rightFace, float faceZoom){
    super(displayAreaX, displayAreaY, displayAreaWidth, displayAreaHeight, leftFace, rightFace, faceZoom);
  }

  @Override
  void drawBackground2PGraphics(PImage pImage){
    int pImageWidth = pImage.pixelWidth;
    int pImageHeight = pImage.pixelHeight;
    int alphaValue;
    int colorValue;

    changedpImage = createImage(pImageWidth, pImageHeight, pImage.format);
    alphaValue = pImage.pixels[0];
    for (int i=0; i<pImageHeight; i++){
      for (int j=0; j<pImageWidth; j++){
        colorValue = pImage.pixels[i*pImageWidth+j];
        if ( !changeColor(alphaValue, colorValue, changeRange) ){
          colorValue = 0xFF0000FF;
        }
        changedpImage.pixels[i*pImageWidth+j] = colorValue;
      }
    }
    
    super.pg.beginDraw(); 
      super.pg.background(changedpImage);
    super.pg.endDraw();
  }
  
  Boolean changeColor(int alphaValue, int colorValue, int range){

    int alphaRed = (alphaValue >> 16) & 0xFF;
    int alphaGreen = (alphaValue >>  8) & 0xFF;
    int alphaBlue = (alphaValue      ) & 0xFF;
    int colorRed = (colorValue >> 16) & 0xFF;
    int colorGreen = (colorValue >>  8) & 0xFF;
    int colorBlue = (colorValue      ) & 0xFF;
    Boolean r = ( ( alphaRed   - range ) <= colorRed   ) && ( colorRed   <= ( alphaRed   + range ) );
    Boolean g = ( ( alphaGreen - range ) <= colorGreen ) && ( colorGreen <= ( alphaGreen + range ) );
    Boolean b = ( ( alphaBlue  - range ) <= colorBlue  ) && ( colorBlue  <= ( alphaBlue  + range ) );
    return r && g && b;
    
  }
 
}