abstract class MovieEffect{
  
  int[] displayArea;
  PImage leftFace;
  PImage rightFace;
  float faceZoom;
  PGraphics pg;
  
  MovieEffect(int displayAreaX, int displayAreaY, int displayAreaWidth, int displayAreaHeight, PImage leftFace, PImage rightFace, float faceZoom){
    this.displayArea = new int[]{displayAreaX, displayAreaY, displayAreaWidth, displayAreaHeight};
    this.leftFace = leftFace.get();
    this.rightFace = rightFace.get();
    this.faceZoom = faceZoom;
  }

  void draw(PImage pImage, Rectangle[] faceCoordinate){
    this.pg = createGraphics(pImage.width, pImage.height);
    drawBackground2PGraphics(pImage);
    drawFaceImage2PGraphics(faceCoordinate);
    image(pg, displayArea[0], displayArea[1], displayArea[2], displayArea[3]);
    pg.removeCache(movie);
  }
  
  void drawBackground2PGraphics(PImage pImage){
    this.pg.beginDraw();
      this.pg.background(pImage);
    this.pg.endDraw();
  }

  void drawFaceImage2PGraphics(Rectangle[] faceCoordinate){
    int centerX;
    int faceMaxNumber = faceCoordinate.length;
    PImage faceImage;

    this.pg.imageMode(CENTER);
    noStroke();
    this.pg.beginDraw();
      for (int i = 0; i < faceMaxNumber; i++) { // 顔認識領域を描画
        centerX = faceCoordinate[i].x+faceCoordinate[i].width/2;
        if (centerX <= pg.width/2){
          faceImage = this.leftFace;
        }else {
          faceImage = this.rightFace;
        }          
        this.pg.image(faceImage, centerX, faceCoordinate[i].y+faceCoordinate[i].height/2, faceZoom*faceCoordinate[i].width, faceZoom*faceCoordinate[i].height);
      }
    this.pg.endDraw();
  }

} // class MovieEffect